// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/driver/18ai32ssc1m.h $
// $Rev: 53598 $
// $Date: 2023-08-23 16:05:50 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Device Driver: header file

#ifndef	__18AI32SSC1M_H__
#define	__18AI32SSC1M_H__

#include "gsc_common.h"
#include "gsc_pci9056.h"



// macros *********************************************************************

#define	AI32SSC1M_BASE_NAME					"18ai32ssc1m"

// IOCTL command codes
#define	AI32SSC1M_IOCTL_REG_READ			OS_IOCTL_RW( 0,  12, gsc_reg_t)
#define	AI32SSC1M_IOCTL_REG_WRITE			OS_IOCTL_W ( 1,  12, gsc_reg_t)
#define	AI32SSC1M_IOCTL_REG_MOD				OS_IOCTL_W ( 2,  12, gsc_reg_t)
#define	AI32SSC1M_IOCTL_QUERY				OS_IOCTL_RW( 3,	  4, s32)
#define	AI32SSC1M_IOCTL_INITIALIZE			OS_IOCTL   ( 4)
#define	AI32SSC1M_IOCTL_AUTOCAL				OS_IOCTL   ( 5)
#define	AI32SSC1M_IOCTL_AUTOCAL_BG			OS_IOCTL_RW( 6,	  4, s32)
#define	AI32SSC1M_IOCTL_RX_IO_MODE			OS_IOCTL_RW( 7,	  4, s32)
#define	AI32SSC1M_IOCTL_RX_IO_OVERFLOW		OS_IOCTL_RW( 8,	  4, s32)
#define	AI32SSC1M_IOCTL_RX_IO_TIMEOUT		OS_IOCTL_RW( 9,	  4, s32)
#define	AI32SSC1M_IOCTL_RX_IO_UNDERFLOW		OS_IOCTL_RW(10,	  4, s32)
#define	AI32SSC1M_IOCTL_AIN_BUF_CLEAR		OS_IOCTL   (11)
#define	AI32SSC1M_IOCTL_AIN_BUF_LEVEL		OS_IOCTL_R (12,	  4, s32)
#define	AI32SSC1M_IOCTL_AIN_BUF_OVERFLOW	OS_IOCTL_RW(13,	  4, s32)
#define	AI32SSC1M_IOCTL_AIN_BUF_THR_LVL		OS_IOCTL_RW(14,	  4, s32)
#define	AI32SSC1M_IOCTL_AIN_BUF_THR_STS		OS_IOCTL_R (15,	  4, s32)
#define	AI32SSC1M_IOCTL_AIN_BUF_UNDERFLOW	OS_IOCTL_RW(16,	  4, s32)
#define	AI32SSC1M_IOCTL_AIN_MODE			OS_IOCTL_RW(17,	  4, s32)
#define	AI32SSC1M_IOCTL_AIN_RANGE			OS_IOCTL_RW(18,	  4, s32)
#define	AI32SSC1M_IOCTL_BURST_BUSY			OS_IOCTL_R (19,	  4, s32)
#define	AI32SSC1M_IOCTL_BURST_SIZE			OS_IOCTL_RW(20,	  4, s32)
#define	AI32SSC1M_IOCTL_BURST_SYNC			OS_IOCTL_RW(21,	  4, s32)
#define	AI32SSC1M_IOCTL_CHAN_ACTIVE			OS_IOCTL_RW(22,	  4, s32)
#define	AI32SSC1M_IOCTL_CHAN_FIRST			OS_IOCTL_RW(23,	  4, s32)
#define	AI32SSC1M_IOCTL_CHAN_LAST			OS_IOCTL_RW(24,	  4, s32)
#define	AI32SSC1M_IOCTL_CHAN_SINGLE			OS_IOCTL_RW(25,	  4, s32)
#define	AI32SSC1M_IOCTL_CLOCK_ENABLE		OS_IOCTL_RW(26,	  4, s32)
#define	AI32SSC1M_IOCTL_DATA_FORMAT			OS_IOCTL_RW(27,	  4, s32)
#define	AI32SSC1M_IOCTL_DATA_PACKING		OS_IOCTL_RW(28,	  4, s32)
#define	AI32SSC1M_IOCTL_DATA_WIDTH			OS_IOCTL_RW(29,	  4, s32)
#define	AI32SSC1M_IOCTL_INPUT_SYNC			OS_IOCTL   (30)
#define	AI32SSC1M_IOCTL_IO_INV				OS_IOCTL_RW(31,	  4, s32)
#define	AI32SSC1M_IOCTL_IRQ0_SEL			OS_IOCTL_RW(32,	  4, s32)
#define	AI32SSC1M_IOCTL_IRQ1_SEL			OS_IOCTL_RW(33,	  4, s32)
#define	AI32SSC1M_IOCTL_RAG_ENABLE			OS_IOCTL_RW(34,	  4, s32)
#define	AI32SSC1M_IOCTL_RAG_NRATE			OS_IOCTL_RW(35,	  4, s32)
#define	AI32SSC1M_IOCTL_RBG_CLK_SRC			OS_IOCTL_RW(36,	  4, s32)
#define	AI32SSC1M_IOCTL_RBG_ENABLE			OS_IOCTL_RW(37,	  4, s32)
#define	AI32SSC1M_IOCTL_RBG_NRATE			OS_IOCTL_RW(38,	  4, s32)
#define	AI32SSC1M_IOCTL_SAMP_CLK_SRC		OS_IOCTL_RW(39,	  4, s32)
#define	AI32SSC1M_IOCTL_SCAN_MARKER			OS_IOCTL_RW(40,	  4, s32)
#define	AI32SSC1M_IOCTL_AUX_CLK_MODE		OS_IOCTL_RW(41,	  4, s32)
#define	AI32SSC1M_IOCTL_AUX_IN_POL			OS_IOCTL_RW(42,	  4, s32)
#define	AI32SSC1M_IOCTL_AUX_NOISE			OS_IOCTL_RW(43,	  4, s32)
#define	AI32SSC1M_IOCTL_AUX_OUT_POL			OS_IOCTL_RW(44,	  4, s32)
#define	AI32SSC1M_IOCTL_AUX_SYNC_MODE		OS_IOCTL_RW(45,	  4, s32)
#define	AI32SSC1M_IOCTL_PRETRIG				OS_IOCTL_RW(46,	  4, s32)
#define	AI32SSC1M_IOCTL_PRETRIG_LATCH		OS_IOCTL_RW(47,	  4, s32)
//#define	AI32SSC1M_IOCTL_PRETRIG_DELAY	OS_IOCTL_RW(48,	  4, s32)	DIAGNOSTIC ONLY, NO LONGER SUPPORTED
#define	AI32SSC1M_IOCTL_RX_IO_ABORT			OS_IOCTL_R (49,	  4, s32)
#define	AI32SSC1M_IOCTL_VPD_READ			OS_IOCTL_RW(50, 136, gsc_vpd_t)
#define	AI32SSC1M_IOCTL_WAIT_EVENT			OS_IOCTL_RW(51,  28, gsc_wait_t)
#define	AI32SSC1M_IOCTL_WAIT_CANCEL			OS_IOCTL_RW(52,  28, gsc_wait_t)
#define	AI32SSC1M_IOCTL_WAIT_STATUS			OS_IOCTL_RW(53,  28, gsc_wait_t)
#define	AI32SSC1M_IOCTL_PRETRIG_COUNT		OS_IOCTL_R (54,	  8, ai32ssc1m_pretrig_count_t)
#define	AI32SSC1M_IOCTL_SCAN_MARKER_GET		OS_IOCTL_R (55,	  4, u32)
#define	AI32SSC1M_IOCTL_SCAN_MARKER_SET		OS_IOCTL_W (56,	  4, u32)
#define	AI32SSC1M_IOCTL_EXT_CLK_DIV_ENA		OS_IOCTL_RW(57,	  4, s32)
#define	AI32SSC1M_IOCTL_EXT_CLK_DIV_VAL		OS_IOCTL_RW(58,	  4, s32)
#define	AI32SSC1M_IOCTL_AUTOCAL_STATUS		OS_IOCTL_R (59,	  4, s32)

//*****************************************************************************
// AI32SSC1M_IOCTL_REG_READ
// AI32SSC1M_IOCTL_REG_WRITE
// AI32SSC1M_IOCTL_REG_MOD
//
#define	AI32SSC1M_REG_ENCODE(s,o)			GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	AI32SSC1M_GSC_BCTLR					AI32SSC1M_REG_ENCODE(4,0x00)// Board Control Register
#define	AI32SSC1M_GSC_ICR					AI32SSC1M_REG_ENCODE(4,0x04)// Interrupt Control Register
#define	AI32SSC1M_GSC_IBDR					AI32SSC1M_REG_ENCODE(4,0x08)// Input Buffer Data Register
#define	AI32SSC1M_GSC_IBCR					AI32SSC1M_REG_ENCODE(4,0x0C)// Input Buffer Control Register
#define	AI32SSC1M_GSC_RAGR					AI32SSC1M_REG_ENCODE(4,0x10)// Rate-A Generator Register
#define	AI32SSC1M_GSC_RBGR					AI32SSC1M_REG_ENCODE(4,0x14)// Rate-B Generator Register
#define	AI32SSC1M_GSC_BUFSR					AI32SSC1M_REG_ENCODE(4,0x18)// Buffer Size Register
#define	AI32SSC1M_GSC_BSTSR					AI32SSC1M_REG_ENCODE(4,0x1C)// Burst Size Register
#define	AI32SSC1M_GSC_SSCR					AI32SSC1M_REG_ENCODE(4,0x20)// Scan & Sync Control Register
#define	AI32SSC1M_GSC_ACAR					AI32SSC1M_REG_ENCODE(4,0x24)// Active Channel Assignment Register
#define	AI32SSC1M_GSC_BCFGR					AI32SSC1M_REG_ENCODE(4,0x28)// Board Configuration Register
#define	AI32SSC1M_GSC_AVR					AI32SSC1M_REG_ENCODE(4,0x2C)// Auto Cal Values Register
#define	AI32SSC1M_GSC_ARWR					AI32SSC1M_REG_ENCODE(4,0x30)// Auxiliary Read/Write Register
#define	AI32SSC1M_GSC_ASIOCR				AI32SSC1M_REG_ENCODE(4,0x34)// Auxiliary Sync I/O Control Register
#define	AI32SSC1M_GSC_SMUWR					AI32SSC1M_REG_ENCODE(4,0x38)// Scan Marker Upper Word Register
#define	AI32SSC1M_GSC_SMLWR					AI32SSC1M_REG_ENCODE(4,0x3C)// Scan Marker Lower Word Register
#define	AI32SSC1M_GSC_TUR					AI32SSC1M_REG_ENCODE(4,0x40)// Test Utility Register
#define	AI32SSC1M_GSC_PTCLR					AI32SSC1M_REG_ENCODE(4,0x44)// Pretrigger Counter Low Register
#define	AI32SSC1M_GSC_PTCHR					AI32SSC1M_REG_ENCODE(4,0x48)// Pretrigger Counter High Register
#define	AI32SSC1M_GSC_ECDR					AI32SSC1M_REG_ENCODE(4,0x54)// External Clock Divisor Register

//*****************************************************************************
// AI32SSC1M_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
		AI32SSC1M_QUERY_AUTOCAL_BG,		// Is Back Ground Autocal supported?
		AI32SSC1M_QUERY_AUTOCAL_MS,		// Max autocalibrate period in ms.
		AI32SSC1M_QUERY_CHANNEL_MAX,	// Maximum number of channels supported.
		AI32SSC1M_QUERY_CHANNEL_QTY,	// BCFGR D16-D17: The number of A/D channels.
		AI32SSC1M_QUERY_COUNT,			// How many query options are supported?
		AI32SSC1M_QUERY_DATA_WIDTH,		// BCFGR D20: Native data width of device in bits.
		AI32SSC1M_QUERY_DEVICE_TYPE,	// Value from gsc_dev_type_t
		AI32SSC1M_QUERY_FGEN_MAX,		// Rate Generator maximum output rate.
		AI32SSC1M_QUERY_FGEN_MIN,		// Rate Generator minimum output rate.
		AI32SSC1M_QUERY_FIFO_SIZE,		// FIFO depth in 32-bit samples
		AI32SSC1M_QUERY_FSAMP_MAX,		// The maximum sample rate per channel.
		AI32SSC1M_QUERY_FSAMP_MIN,		// The minimum sample rate per channel.
		AI32SSC1M_QUERY_INIT_MS,		// Max initialize period in ms.
		AI32SSC1M_QUERY_MASTER_CLOCK,	// BCFGR D18: Master clock frequency
		AI32SSC1M_QUERY_NRATE_MASK,		// Mask of valid Nrate bits.
		AI32SSC1M_QUERY_NRATE_MAX,		// Maximum rate generator Nrate value.
		AI32SSC1M_QUERY_NRATE_MIN,		// Maximum rate generator Nrate value.
		AI32SSC1M_QUERY_RATE_GEN_QTY,	// Number of Rate Generatorts.
		AI32SSC1M_QUERY_V_RANGE,		// BCFGR D19: Voltage Range option
		AI32SSC1M_QUERY_PRETRIG,		// Is Pretriggering available?
		AI32SSC1M_QUERY_EXT_CLK_DIV,	// Is the External Clock Divisor available?
		AI32SSC1M_IOCTL_QUERY_LAST
} ai32ssc1m_query_t;

#define	AI32SSC1M_IOCTL_QUERY_ERROR			(-1)

// Option responses for xxx.
#define	AI32SSC1M_QUERY_V_RANGE_2_5			0
#define	AI32SSC1M_QUERY_V_RANGE_10V			1

// Retained for backwards compatibility only:
#define	AI32SSC1M_QUERY_AUTO_CAL_BG			AI32SSC1M_QUERY_AUTOCAL_BG
#define	AI32SSC1M_QUERY_AUTO_CAL_MS			AI32SSC1M_QUERY_AUTOCAL_MS

//*****************************************************************************
// AI32SSC1M_IOCTL_INITIALIZE				BCTLR D15
//
//	Parameter:	None

//*****************************************************************************
// AI32SSC1M_IOCTL_AUTOCAL					BCTLR D13, D14
//
//	Parameter:	None

// Retained for backwards compatibility only:
#define	AI32SSC1M_IOCTL_AUTO_CALIBRATE		AI32SSC1M_IOCTL_AUTOCAL

//*****************************************************************************
// AI32SSC1M_IOCTL_AUTOCAL_BG				BCTLR D8
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_AUTOCAL_BG_DISABLE		0
#define	AI32SSC1M_AUTOCAL_BG_ENABLE			1

// Retained for backwards compatibility only:
#define	AI32SSC1M_IOCTL_AUTO_CAL_BG			AI32SSC1M_IOCTL_AUTOCAL_BG
#define	AI32SSC1M_AUTO_CAL_BG_DISABLE		AI32SSC1M_AUTOCAL_BG_DISABLE
#define	AI32SSC1M_AUTO_CAL_BG_ENABLE		AI32SSC1M_AUTOCAL_BG_ENABLE

//*****************************************************************************
// AI32SSC1M_IOCTL_RX_IO_MODE
//
//	Parameter:	s32*
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	AI32SSC1M_IO_MODE_DEFAULT			GSC_IO_MODE_PIO

//*****************************************************************************
// AI32SSC1M_IOCTL_RX_IO_OVERFLOW
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_IO_OVERFLOW_DEFAULT		AI32SSC1M_IO_OVERFLOW_CHECK
#define	AI32SSC1M_IO_OVERFLOW_IGNORE		0
#define	AI32SSC1M_IO_OVERFLOW_CHECK			1

//*****************************************************************************
// AI32SSC1M_IOCTL_RX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32*
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	AI32SSC1M_IO_TIMEOUT_DEFAULT		10
#define	AI32SSC1M_IO_TIMEOUT_NO_SLEEP		0
#define	AI32SSC1M_IO_TIMEOUT_MIN			0
#define	AI32SSC1M_IO_TIMEOUT_MAX			GSC_IO_TIMEOUT_MAX
#define	AI32SSC1M_IO_TIMEOUT_INFINITE		GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// AI32SSC1M_IOCTL_RX_IO_UNDERFLOW
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_IO_UNDERFLOW_DEFAULT		AI32SSC1M_IO_UNDERFLOW_CHECK
#define	AI32SSC1M_IO_UNDERFLOW_IGNORE		0
#define	AI32SSC1M_IO_UNDERFLOW_CHECK		1

//*****************************************************************************
// AI32SSC1M_IOCTL_AIN_BUF_CLEAR			IBCR D18
//
//	Parameter:	None.

//*****************************************************************************
// AI32SSC1M_IOCTL_AIN_BUF_LEVEL			BUFSR D0-D18
//
//	Parameter:	s32*
//		The value returned is the current input buffer fill level.

//*****************************************************************************
// AI32SSC1M_IOCTL_AIN_BUF_OVERFLOW			BCTLR D17
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AI32SSC1M_AIN_BUF_OVERFLOW_CLEAR	0
#define	AI32SSC1M_AIN_BUF_OVERFLOW_IGNORE	1

// For queries the following values are returned.
#define	AI32SSC1M_AIN_BUF_OVERFLOW_NO		0
#define	AI32SSC1M_AIN_BUF_OVERFLOW_YES		1

//*****************************************************************************
// AI32SSC1M_IOCTL_AIN_BUF_THR_LVL			IBCR D0-D17
//
//	Parameter:	s32*
//		Pass in any valid value from 0x0 to 0x3FFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AI32SSC1M_IOCTL_AIN_BUF_THR_STS			IBCR D19
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AI32SSC1M_AIN_BUF_THR_STS_CLEAR		0
#define	AI32SSC1M_AIN_BUF_THR_STS_SET		1

//*****************************************************************************
// AI32SSC1M_IOCTL_AIN_BUF_UNDERFLOW		BCTLR D16
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_AIN_BUF_UNDERFLOW_CLEAR	0
#define	AI32SSC1M_AIN_BUF_UNDERFLOW_IGNORE	1

// For queries the following values are returned.
#define	AI32SSC1M_AIN_BUF_UNDERFLOW_NO		0
#define	AI32SSC1M_AIN_BUF_UNDERFLOW_YES		1

//*****************************************************************************
// AI32SSC1M_IOCTL_AIN_MODE					BCTLR D0-D3
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_AIN_MODE_DIFF				0	// Differential
#define	AI32SSC1M_AIN_MODE_ZERO				2	// Zero test
#define	AI32SSC1M_AIN_MODE_VREF				3	// Vref test

//*****************************************************************************
// AI32SSC1M_IOCTL_AIN_RANGE				BCTLR D4-D5
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_AIN_RANGE_1_25V			3	// +- 1.25 volts
#define	AI32SSC1M_AIN_RANGE_2_5V			4	// +- 2.5 volts
#define	AI32SSC1M_AIN_RANGE_5V				1	// +- 5 volts
#define	AI32SSC1M_AIN_RANGE_10V				2	// +- 10 volts

//*****************************************************************************
// AI32SSC1M_IOCTL_BURST_BUSY				SSCR D7
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AI32SSC1M_BURST_BUSY_IDLE			0
#define	AI32SSC1M_BURST_BUSY_ACTIVE			1

//*****************************************************************************
// AI32SSC1M_IOCTL_BURST_SIZE				BSTSR D0-D19
//
//	Parameter:	s32*
//		Pass in any value between the below inclusive limits, or
//		-1 to read the current setting.
//		At this time the valid range is 0-0xFFFFF.

//*****************************************************************************
// AI32SSC1M_IOCTL_BURST_SYNC				SSCR D8-D9
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_BURST_SYNC_DISABLE		0
#define	AI32SSC1M_BURST_SYNC_RBG			1
#define	AI32SSC1M_BURST_SYNC_EXT			2
#define	AI32SSC1M_BURST_SYNC_BCR			3

//*****************************************************************************
// AI32SSC1M_IOCTL_CHAN_ACTIVE				SSCR D0-D2
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_CHAN_ACTIVE_SINGLE		0
#define	AI32SSC1M_CHAN_ACTIVE_0_1			1
#define	AI32SSC1M_CHAN_ACTIVE_0_3			2
#define	AI32SSC1M_CHAN_ACTIVE_0_7			3
#define	AI32SSC1M_CHAN_ACTIVE_0_15			4
#define	AI32SSC1M_CHAN_ACTIVE_0_31			5
#define	AI32SSC1M_CHAN_ACTIVE_RANGE			7

//*****************************************************************************
// AI32SSC1M_IOCTL_CHAN_FIRST				ACAR D0-D7
//
//	Parameter:	s32*
//		Pass in any valid value from zero to the index of the last channel,
//		but not more than the LAST channel selection, or
//		-1 to read the current setting.

//*****************************************************************************
// AI32SSC1M_IOCTL_CHAN_LAST				ACAR D8-D15
//
//	Parameter:	s32*
//		Pass in any valid value from zero to the index of the last channel,
//		but not less than the FIRST channel selection, or
//		-1 to read the current setting.

//*****************************************************************************
// AI32SSC1M_IOCTL_CHAN_SINGLE				SSCR D12-D17
//
//	Parameter:	s32*
//		Pass in any valid value from zero to the index of the last channel, or
//		-1 to read the current setting.

//*****************************************************************************
// AI32SSC1M_IOCTL_CLOCK_ENABLE				SSCR D5
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AI32SSC1M_CLOCK_ENABLE_NO			0	// Disable clocking
#define	AI32SSC1M_CLOCK_ENABLE_YES			1	// Enable clocking

//*****************************************************************************
// AI32SSC1M_IOCTL_DATA_FORMAT				BCTLR D6
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_DATA_FORMAT_2S_COMP		0	// Twos Compliment
#define	AI32SSC1M_DATA_FORMAT_OFF_BIN		1	// Offset Binary

//*****************************************************************************
// AI32SSC1M_IOCTL_DATA_PACKING				BCTLR D18
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_DATA_PACKING_DISABLE		0
#define	AI32SSC1M_DATA_PACKING_ENABLE		1

//*****************************************************************************
// AI32SSC1M_IOCTL_DATA_WIDTH				IBCR D20
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_DATA_WIDTH_16				0
#define	AI32SSC1M_DATA_WIDTH_18				1

//*****************************************************************************
// AI32SSC1M_IOCTL_INPUT_SYNC				BCTLR D12
//
//	Parameter:	None.

//*****************************************************************************
// AI32SSC1M_IOCTL_IO_INV					SSCR D11
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_IO_INV_LOW				0	// assert LOW
#define	AI32SSC1M_IO_INV_HIGH				1	// assert HI

//*****************************************************************************
// AI32SSC1M_IOCTL_IRQ0_SEL					ICR D0-D2
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_IRQ0_INIT_DONE			0
#define	AI32SSC1M_IRQ0_AUTOCAL_DONE			1
#define	AI32SSC1M_IRQ0_SYNC_START			2
#define	AI32SSC1M_IRQ0_SYNC_DONE			3
#define	AI32SSC1M_IRQ0_BURST_START			4
#define	AI32SSC1M_IRQ0_BURST_DONE			5

// Retained for backwards compatibility only:
#define	AI32SSC1M_IRQ0_AUTO_CAL_DONE		AI32SSC1M_IRQ0_AUTOCAL_DONE

//*****************************************************************************
// AI32SSC1M_IOCTL_IRQ1_SEL					ICR D4-D6
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_IRQ1_NONE					0
#define	AI32SSC1M_IRQ1_IN_BUF_THR_L2H		1
#define	AI32SSC1M_IRQ1_IN_BUF_THR_H2L		2
#define	AI32SSC1M_IRQ1_IN_BUF_OVR_UNDR		3

//*****************************************************************************
// AI32SSC1M_IOCTL_RAG_ENABLE				RAGR D16
// AI32SSC1M_IOCTL_RBG_ENABLE				RBGR D16
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_GEN_ENABLE_NO				1
#define	AI32SSC1M_GEN_ENABLE_YES			0

//*****************************************************************************
// AI32SSC1M_IOCTL_RAG_NRATE				RAGR D0-D15
// AI32SSC1M_IOCTL_RBG_NRATE				RBGR D0-D15
//
//	Parameter:	s32*
//		Pass in any value between the below inclusive limits, or
//		-1 to read the current setting.
//		At this time the valid range is 36-0xFFFF.

//*****************************************************************************
// AI32SSC1M_IOCTL_RBG_CLK_SRC				SSCR D10
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_RBG_CLK_SRC_MASTER		0
#define	AI32SSC1M_RBG_CLK_SRC_RAG			1

//*****************************************************************************
// AI32SSC1M_IOCTL_SAMP_CLK_SRC				SSCR D3-D4
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_SAMP_CLK_SRC_EXT			0
#define	AI32SSC1M_SAMP_CLK_SRC_RAG			1
#define	AI32SSC1M_SAMP_CLK_SRC_RBG			2
#define	AI32SSC1M_SAMP_CLK_SRC_BCR			3

//*****************************************************************************
// AI32SSC1M_IOCTL_SCAN_MARKER				BCTLR D11
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_SCAN_MARKER_DISABLE		1
#define	AI32SSC1M_SCAN_MARKER_ENABLE		0

//*****************************************************************************
// AI32SSC1M_IOCTL_AUX_CLK_MODE				ASIOCR D0-D1
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_AUX_CLK_MODE_DISABLE		0
#define	AI32SSC1M_AUX_CLK_MODE_INPUT		1
#define	AI32SSC1M_AUX_CLK_MODE_OUTPUT		2

//*****************************************************************************
// AI32SSC1M_IOCTL_AUX_IN_POL				ASIOCR D8
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_AUX_IN_POL_LO_2_HI		0
#define	AI32SSC1M_AUX_IN_POL_HI_2_LO		1

//*****************************************************************************
// AI32SSC1M_IOCTL_AUX_NOISE				ASIOCR D10
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_AUX_NOISE_LOW				0
#define	AI32SSC1M_AUX_NOISE_HIGH			1

//*****************************************************************************
// AI32SSC1M_IOCTL_AUX_OUT_POL				ASIOCR D9
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_AUX_OUT_POL_HI_PULSE		0
#define	AI32SSC1M_AUX_OUT_POL_LOW_PULSE		1

//*****************************************************************************
// AI32SSC1M_IOCTL_AUX_SYNC_MODE			ASIOCR D2-D3
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_AUX_SYNC_MODE_DISABLE		0
#define	AI32SSC1M_AUX_SYNC_MODE_INPUT		1
#define	AI32SSC1M_AUX_SYNC_MODE_OUTPUT		2

//*****************************************************************************
// AI32SSC1M_IOCTL_PRETRIG					SSCR D18
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_PRETRIG_DISABLE			0
#define	AI32SSC1M_PRETRIG_ENABLE			1

//*****************************************************************************
// AI32SSC1M_IOCTL_PRETRIG_LATCH			SSCR D19
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AI32SSC1M_PRETRIG_LATCH_CLEAR		0
#define	AI32SSC1M_PRETRIG_LATCH_IGNORE		(-1)

// For queries the following values are returned.
#define	AI32SSC1M_PRETRIG_LATCH_IDLE		0
#define	AI32SSC1M_PRETRIG_LATCH_ACTIVE		1

//*****************************************************************************
// AI32SSC1M_IOCTL_RX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	AI32SSC1M_IO_ABORT_NO				0
#define	AI32SSC1M_IO_ABORT_YES				1

//*****************************************************************************
// AI32SSC1M_IOCTL_VPD_READ - NOT IMPLEMENTED ON 18AI32SSC1M DEVICES.
//
//	Parameter:	gsc_vpd_t*
// gsc_vpd_t.type - see gsc_common.h
// gsc_vpd_t.reserved - see gsc_common.h
// gsc_vpd_t.data - filled in according to the requested "type" above

//*****************************************************************************
// AI32SSC1M_IOCTL_WAIT_EVENT				all fields must be valid
// AI32SSC1M_IOCTL_WAIT_CANCEL				fields need not be valid
// AI32SSC1M_IOCTL_WAIT_STATUS				fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	AI32SSC1M_WAIT_GSC_INIT_DONE		0x0001
#define	AI32SSC1M_WAIT_GSC_AUTOCAL_DONE		0x0002
#define	AI32SSC1M_WAIT_GSC_SYNC_START		0x0004
#define	AI32SSC1M_WAIT_GSC_SYNC_DONE		0x0008
#define	AI32SSC1M_WAIT_GSC_BURST_START		0x0010
#define	AI32SSC1M_WAIT_GSC_BURST_DONE		0x0020
#define	AI32SSC1M_WAIT_GSC_IN_BUF_THR_L2H	0x0040
#define	AI32SSC1M_WAIT_GSC_IN_BUF_THR_H2L	0x0080
#define	AI32SSC1M_WAIT_GSC_IN_BUF_OVR_UNDR	0x0100
#define	AI32SSC1M_WAIT_GSC_ALL				0x01FF
// gsc_wait_t.alt flags
#define	AI32SSC1M_WAIT_ALT_ALL				0x0000
// gsc_wait_t.io
#define	AI32SSC1M_WAIT_IO_RX_ABORT			0x0001
#define	AI32SSC1M_WAIT_IO_RX_DONE			0x0002
#define	AI32SSC1M_WAIT_IO_RX_ERROR			0x0004
#define	AI32SSC1M_WAIT_IO_RX_TIMEOUT		0x0008

#define	AI32SSC1M_WAIT_IO_ALL				0x000F

// Retained for backwards compatibility only:
#define	AI32SSC1M_WAIT_GSC_AUTO_CAL_DONE	AI32SSC1M_WAIT_GSC_AUTOCAL_DONE

//*****************************************************************************
// AI32SSC1M_IOCTL_PRETRIG_COUNT			PTCLR D0-D31, PTCHR D0-D15
//
//	Parameter:	ai32ssc1m_pretrig_count_t*
//		Valid values are from 0x0 to 0xFFFF FFFF FFFF.

typedef struct
{
	u32	low;	// all 32 bits
	u32	high;	// lower 16 bits
} ai32ssc1m_pretrig_count_t;

//*****************************************************************************
// AI32SSC1M_IOCTL_SCAN_MARKER_GET			SMLWR D0-D15, SMUWR D0-D15
// AI32SSC1M_IOCTL_SCAN_MARKER_SET			SMLWR D0-D15, SMUWR D0-D15
//
//	Parameter:	u32*
//		Valid values are from 0x0 to 0xFFFFFFFF.


//*****************************************************************************
// AI32SSC1M_IOCTL_EXT_CLK_DIV_ENA			SSCR D6
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	AI32SSC1M_EXT_CLK_DIV_ENA_NO		0
#define	AI32SSC1M_EXT_CLK_DIV_ENA_YES		1

//*****************************************************************************
// AI32SSC1M_IOCTL_EXT_CLK_DIV_VAL			ECDR D0-D19
//
//	Parameter:	s32*
//		Pass in any valid value from 0x0 to 0xFFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AI32SSC1M_IOCTL_AUTOCAL_STATUS			BCTLR D13, D14
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AI32SSC1M_AUTOCAL_STATUS_ACTIVE		0
#define	AI32SSC1M_AUTOCAL_STATUS_FAIL		1
#define	AI32SSC1M_AUTOCAL_STATUS_PASS		2



#endif
