// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/include/18ai32ssc1m_utils.h $
// $Rev: 53588 $
// $Date: 2023-08-23 15:31:06 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Utilities: header file

#ifndef	__18AI32SSC1M_UTILS_H__
#define	__18AI32SSC1M_UTILS_H__

#include "18ai32ssc1m_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	ai32ssc1m_close_util			(int fd, int index, int verbose);
int ai32ssc1m_init_util				(int verbose);
int ai32ssc1m_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	ai32ssc1m_open_util				(int device, int share, int index, int verbose, int* fd);
int	ai32ssc1m_read_util				(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got);

// IOCTL utility services

int	ai32ssc1m_ain_buf_clear			(int fd, int index, int verbose, int at_boundary);						// AI32SSC1M_IOCTL_AIN_BUF_CLEAR
int	ai32ssc1m_ain_buf_level			(int fd, int index, int verbose, s32* get);								// AI32SSC1M_IOCTL_AIN_BUF_LEVEL
int	ai32ssc1m_ain_buf_overflow		(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_AIN_BUF_OVERFLOW
int	ai32ssc1m_ain_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_AIN_BUF_THR_LVL
int	ai32ssc1m_ain_buf_thr_sts		(int fd, int index, int verbose, s32* get);								// AI32SSC1M_IOCTL_AIN_BUF_THR_STS
int	ai32ssc1m_ain_buf_underflow		(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_AIN_BUF_UNDERFLOW
int	ai32ssc1m_ain_mode				(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_AIN_MODE
int	ai32ssc1m_ain_range				(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_AIN_RANGE
int	ai32ssc1m_autocal				(int fd, int index, int verbose);										// AI32SSC1M_IOCTL_AUTOCAL
int	ai32ssc1m_autocal_bg			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_AUTOCAL_BG
int	ai32ssc1m_autocal_status		(int fd, int index, int verbose, s32* get);								// AI32SSC1M_IOCTL_AUTOCAL_STATUS
int	ai32ssc1m_aux_clk_mode			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_AUX_CLK_MODE
int	ai32ssc1m_aux_in_pol			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_AUX_IN_POL
int	ai32ssc1m_aux_noise				(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_AUX_NOISE
int	ai32ssc1m_aux_out_pol			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_AUX_OUT_POL
int	ai32ssc1m_aux_sync_mode			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_AUX_SYNC_MODE
int	ai32ssc1m_burst_busy			(int fd, int index, int verbose, s32* get);								// AI32SSC1M_IOCTL_BURST_BUSY
int	ai32ssc1m_burst_size			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_BURST_SIZE
int	ai32ssc1m_burst_sync			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_BURST_SYNC
int	ai32ssc1m_chan_active			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_CHAN_ACTIVE
int	ai32ssc1m_chan_first			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_CHAN_FIRST
int	ai32ssc1m_chan_last				(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_CHAN_LAST
int	ai32ssc1m_chan_single			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_CHAN_SINGLE
int	ai32ssc1m_clock_enable			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_CLOCK_ENABLE
int	ai32ssc1m_data_format			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_DATA_FORMAT
int	ai32ssc1m_data_packing			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_DATA_PACKING
int	ai32ssc1m_data_width			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_DATA_WIDTH
int	ai32ssc1m_ext_clk_div_ena		(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_EXT_CLK_DIV_ENA
int	ai32ssc1m_ext_clk_div_val		(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_EXT_CLK_DIV_VAL
int	ai32ssc1m_initialize			(int fd, int index, int verbose);										// AI32SSC1M_IOCTL_INITIALIZE
int	ai32ssc1m_input_sync			(int fd, int index, int verbose);										// AI32SSC1M_IOCTL_INPUT_SYNC
int	ai32ssc1m_io_inv				(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_IO_INV
int	ai32ssc1m_irq0_sel				(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_IRQ0_SEL
int	ai32ssc1m_irq1_sel				(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_IRQ1_SEL
int	ai32ssc1m_pretrig				(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_PRETRIG
int	ai32ssc1m_pretrig_count			(int fd, int index, int verbose, u64* get);								// AI32SSC1M_IOCTL_PRETRIG_COUNT
int	ai32ssc1m_pretrig_latch			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_PRETRIG_LATCH
int	ai32ssc1m_query					(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_QUERY
int	ai32ssc1m_rag_enable			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_RAG_ENABLE
int	ai32ssc1m_rag_nrate				(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_RAG_NRATE
int	ai32ssc1m_rbg_clk_src			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_RBG_CLK_SRC
int	ai32ssc1m_rbg_enable			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_RBG_ENABLE
int	ai32ssc1m_rbg_nrate				(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_RBG_NRATE
int	ai32ssc1m_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);			// AI32SSC1M_IOCTL_REG_MOD
int	ai32ssc1m_reg_read				(int fd, int index, int verbose, u32 reg, u32* value);					// AI32SSC1M_IOCTL_REG_READ
int	ai32ssc1m_reg_write				(int fd, int index, int verbose, u32 reg, u32 value);					// AI32SSC1M_IOCTL_REG_WRITE
int	ai32ssc1m_rx_io_abort			(int fd, int index, int verbose, s32* get);								// AI32SSC1M_IOCTL_RX_IO_ABORT
int	ai32ssc1m_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_RX_IO_MODE
int	ai32ssc1m_rx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_RX_IO_OVERFLOW
int	ai32ssc1m_rx_io_timeout			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_RX_IO_TIMEOUT
int	ai32ssc1m_rx_io_underflow		(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_RX_IO_UNDERFLOW
int	ai32ssc1m_samp_clk_src			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_SAMP_CLK_SRC
int	ai32ssc1m_scan_marker			(int fd, int index, int verbose, s32 set, s32* get);					// AI32SSC1M_IOCTL_SCAN_MARKER
int	ai32ssc1m_scan_marker_get		(int fd, int index, int verbose, u32* get);								// AI32SSC1M_IOCTL_SCAN_MARKER_GET
int	ai32ssc1m_scan_marker_set		(int fd, int index, int verbose, u32 set);								// AI32SSC1M_IOCTL_SCAN_MARKER_SET
int	ai32ssc1m_vpd_read				(int fd, int index, int verbose, gsc_vpd_type_t type, gsc_vpd_t* vpd);	// AI32SSC1M_IOCTL_VPD_READ
int	ai32ssc1m_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);						// AI32SSC1M_IOCTL_WAIT_CANCEL
int	ai32ssc1m_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);						// AI32SSC1M_IOCTL_WAIT_EVENT
int	ai32ssc1m_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);						// AI32SSC1M_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	ai32ssc1m_config_ai				(int fd, int index, int verbose, s32 fsamp);
int	ai32ssc1m_config_aux			(int fd, int index, int verbose);
int	ai32ssc1m_config_tt				(int fd, int index, int verbose);
int	ai32ssc1m_fsamp_ai_compute		(int fd, int index, int verbose, s32 fsamp, s32* src, s32* src_b, s32* nrate_a, s32* nrate_b, s32* enable_a, s32* enable_b, double* rate);
int	ai32ssc1m_fsamp_report			(int fd, int index, int verbose, int chan, s32* fsamp);
int	ai32ssc1m_fsamp_report_all		(int fd, int index, int verbose, s32* fsamp);
int	ai32ssc1m_id_device				(int fd, int index, int verbose);
int	ai32ssc1m_vpd_read_model_number	(int fd, int index, int verbose);
int	ai32ssc1m_vpd_read_name			(int fd, int index, int verbose);
int	ai32ssc1m_vpd_read_serial_number(int fd, int index, int verbose);

int	ai32ssc1m_count_boards			(int verbose, s32* get);
int	ai32ssc1m_reg_list				(int fd, int detail);

const gsc_reg_def_t*				ai32ssc1m_reg_get_def_id		(u32 reg);
const gsc_reg_def_t*				ai32ssc1m_reg_get_def_index		(int index);
const char*							ai32ssc1m_reg_get_desc			(u32 reg);
const char*							ai32ssc1m_reg_get_name			(u32 reg);


// Retained for backwards compatibility only:
int	ai32ssc1m_auto_cal_bg			(int fd, int index, int verbose, s32 set, s32* get);
int	ai32ssc1m_auto_calibrate		(int fd, int index, int verbose);


#endif
