// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/samples/sbtest/ain_range.c $
// $Rev: 53596 $
// $Date: 2023-08-23 15:57:48 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list_high[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSC1M_IOCTL_AIN_RANGE,
			/* arg		*/	AI32SSC1M_AIN_RANGE_5V,
			/* reg		*/	AI32SSC1M_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x10
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSC1M_IOCTL_AIN_RANGE,
			/* arg		*/	AI32SSC1M_AIN_RANGE_10V,
			/* reg		*/	AI32SSC1M_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x20
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_low[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSC1M_IOCTL_AIN_RANGE,
			/* arg		*/	AI32SSC1M_AIN_RANGE_1_25V,
			/* reg		*/	AI32SSC1M_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x10
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSC1M_IOCTL_AIN_RANGE,
			/* arg		*/	AI32SSC1M_AIN_RANGE_2_5V,
			/* reg		*/	AI32SSC1M_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x20
		},

		{ SERVICE_END_LIST }
	};

	int						errs;
	const service_data_t*	list;
	s32						range;

	errs	= ai32ssc1m_query(fd, -1, 0, AI32SSC1M_QUERY_V_RANGE, &range);

	if (range == AI32SSC1M_QUERY_V_RANGE_10V)
		list	= list_high;
	else
		list	= list_low;

	errs	+= ai32ssc1m_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

	errs	+= ai32ssc1m_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This test requires external equipment.
	return(0);
}



/******************************************************************************
*
*	Function:	ain_range_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AI32SSC1M_IOCTL_AIN_RANGE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ain_range_test(int fd)
{
	int	errs	= 0;

	gsc_label("AI32SSC1M_IOCTL_AIN_RANGE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


