// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/samples/sbtest/chan_single.c $
// $Rev: 53596 $
// $Date: 2023-08-23 15:57:48 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	s32	args[33];
	int	errs	= 0;
	int	i;
	s32	qty;

	errs	+= ai32ssc1m_query(fd, -1, 0, AI32SSC1M_QUERY_CHANNEL_QTY, &qty);

	if (errs == 0)
	{
		for (i = 0; i < qty; i++)
			args[i]	= i;

		args[i]	= -1;
		errs	+= ai32ssc1m_initialize(fd, -1, 0);
		errs	+= service_test_set_reg_reg_get(
					fd,
					__LINE__,
					AI32SSC1M_IOCTL_CHAN_SINGLE, args,
					AI32SSC1M_GSC_SSCR, 17, 12);
		errs	+= ai32ssc1m_initialize(fd, -1, 0);
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This test requires external equipment.
	return(0);
}



/******************************************************************************
*
*	Function:	chan_single_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AI32SSC1M_IOCTL_CHAN_SINGLE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int chan_single_test(int fd)
{
	int	errs	= 0;

	gsc_label("AI32SSC1M_IOCTL_CHAN_SINGLE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


