// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/samples/sbtest/ext_clk_div_ena.c $
// $Rev: 53596 $
// $Date: 2023-08-23 15:57:48 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const s32	args[]	=
	{
		AI32SSC1M_EXT_CLK_DIV_ENA_NO,
		AI32SSC1M_EXT_CLK_DIV_ENA_YES,
		-1
	};

	int	errs	= 0;

	errs	+= ai32ssc1m_initialize(fd, -1, 0);
	errs	+= service_test_set_reg_reg_get(
				fd,
				__LINE__,
				AI32SSC1M_IOCTL_EXT_CLK_DIV_ENA, args,
				AI32SSC1M_GSC_SSCR, 6, 6);
	errs	+= ai32ssc1m_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// Performing a functional test requires external equipment.
	return(0);
}



/******************************************************************************
*
*	Function:	ext_clk_div_ena_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AI32SSC1M_IOCTL_EXT_CLK_DIV_ENA.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ext_clk_div_ena_test(int fd)
{
	int	errs		= 0;
	s32	ext_clk_div;

	gsc_label("AI32SSC1M_IOCTL_EXT_CLK_DIV_ENA");
	errs	+= ai32ssc1m_query(fd, -1, 0, AI32SSC1M_QUERY_EXT_CLK_DIV, &ext_clk_div);

	if (errs)
	{
		printf("FAIL <---\n");
	}
	else if (ext_clk_div == 0)
	{
		printf("SKIPPED  (Not supported in this firmware.)\n");
	}
	else
	{
		errs	+= _service_test(fd);
		errs	+= _function_test(fd);
		printf("%s\n", errs ? "FAIL <---" : "PASS");
	}

	return(errs);
}


