// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/samples/sbtest/irq0_sel.c $
// $Rev: 53596 $
// $Date: 2023-08-23 15:57:48 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const s32	args[]	=
	{
		AI32SSC1M_IRQ0_INIT_DONE,
		AI32SSC1M_IRQ0_AUTOCAL_DONE,
		AI32SSC1M_IRQ0_SYNC_START,
		AI32SSC1M_IRQ0_SYNC_DONE,
		AI32SSC1M_IRQ0_BURST_START,
		AI32SSC1M_IRQ0_BURST_DONE,
		-1
	};

	int	errs	= 0;

	errs	+= ai32ssc1m_initialize(fd, -1, 0);
	errs	+= service_test_set_reg_reg_get(
				fd,
				__LINE__,
				AI32SSC1M_IOCTL_IRQ0_SEL, args,
				AI32SSC1M_GSC_ICR, 2, 0);
	errs	+= ai32ssc1m_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// These interrupt options are tested via the Wait Event tests.
	return(0);
}



/******************************************************************************
*
*	Function:	irq0_sel_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AI32SSC1M_IOCTL_IRQ0_SEL.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int irq0_sel_test(int fd)
{
	int	errs	= 0;

	gsc_label("AI32SSC1M_IOCTL_IRQ0_SEL");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


