// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/samples/sbtest/perform.c $
// $Rev: 53596 $
// $Date: 2023-08-23 15:57:48 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	errs	+= ain_buf_clear_test(args->fd);		// AI32SSC1M_IOCTL_AIN_BUF_CLEAR
	errs	+= ain_buf_level_test(args->fd);		// AI32SSC1M_IOCTL_AIN_BUF_LEVEL
	errs	+= ain_buf_overflow_test(args->fd);		// AI32SSC1M_IOCTL_AIN_BUF_OVERFLOW
	errs	+= ain_buf_thr_lvl_test(args->fd);		// AI32SSC1M_IOCTL_AIN_BUF_THR_LVL
	errs	+= ain_buf_thr_sts_test(args->fd);		// AI32SSC1M_IOCTL_AIN_BUF_THR_STS
	errs	+= ain_buf_underflow_test(args->fd);	// AI32SSC1M_IOCTL_AIN_BUF_UNDERFLOW
	errs	+= ain_mode_test(args->fd);				// AI32SSC1M_IOCTL_AIN_MODE
	errs	+= ain_range_test(args->fd);			// AI32SSC1M_IOCTL_AIN_RANGE
	errs	+= autocal_test(args->fd);				// AI32SSC1M_IOCTL_AUTOCAL
	errs	+= autocal_bg_test(args->fd);			// AI32SSC1M_IOCTL_AUTOCAL_BG
	errs	+= autocal_status_test(args->fd);		// AI32SSC1M_IOCTL_AUTOCAL_STATUS
	errs	+= aux_clk_mode_test(args->fd);			// AI32SSC1M_IOCTL_AUX_CLK_MODE
	errs	+= aux_in_pol_test(args->fd);			// AI32SSC1M_IOCTL_AUX_IN_POL
	errs	+= aux_noise_test(args->fd);			// AI32SSC1M_IOCTL_AUX_NOISE
	errs	+= aux_out_pol_test(args->fd);			// AI32SSC1M_IOCTL_AUX_OUT_POL
	errs	+= aux_sync_mode_test(args->fd);		// AI32SSC1M_IOCTL_AUX_SYNC_MODE
	errs	+= burst_busy_test(args->fd);			// AI32SSC1M_IOCTL_BURST_BUSY
	errs	+= burst_size_test(args->fd);			// AI32SSC1M_IOCTL_BURST_SIZE
	errs	+= burst_sync_test(args->fd);			// AI32SSC1M_IOCTL_BURST_SYNC
	errs	+= chan_active_test(args->fd);			// AI32SSC1M_IOCTL_CHAN_ACTIVE
	errs	+= chan_first_test(args->fd);			// AI32SSC1M_IOCTL_CHAN_FIRST
	errs	+= chan_last_test(args->fd);			// AI32SSC1M_IOCTL_CHAN_LAST
	errs	+= chan_single_test(args->fd);			// AI32SSC1M_IOCTL_CHAN_SINGLE
	errs	+= clock_enable_test(args->fd);			// AI32SSC1M_IOCTL_CLOCK_ENABLE
	errs	+= data_format_test(args->fd);			// AI32SSC1M_IOCTL_DATA_FORMAT
	errs	+= data_packing_test(args->fd);			// AI32SSC1M_IOCTL_DATA_PACKING
	errs	+= data_width_test(args->fd);			// AI32SSC1M_IOCTL_DATA_WIDTH
	errs	+= ext_clk_div_ena_test(args->fd);		// AI32SSC1M_IOCTL_EXT_CLK_DIV_ENA
	errs	+= ext_clk_div_val_test(args->fd);		// AI32SSC1M_IOCTL_EXT_CLK_DIV_VAL
	errs	+= initialize_test(args->fd);			// AI32SSC1M_IOCTL_INITIALIZE
	errs	+= input_sync_test(args->fd);			// AI32SSC1M_IOCTL_INPUT_SYNC
	errs	+= io_inv_test(args->fd);				// AI32SSC1M_IOCTL_IO_INV
	errs	+= irq0_sel_test(args->fd);				// AI32SSC1M_IOCTL_IRQ0_SEL
	errs	+= irq1_sel_test(args->fd);				// AI32SSC1M_IOCTL_IRQ1_SEL
	errs	+= vpd_read_test(args->fd);				// AI32SSC1M_IOCTL_VPD_READ
	errs	+= pretrig_test(args->fd);				// AI32SSC1M_IOCTL_PRETRIG
	errs	+= pretrig_count_test(args->fd);		// AI32SSC1M_IOCTL_PRETRIG_COUNT
	errs	+= pretrig_latch_test(args->fd);		// AI32SSC1M_IOCTL_PRETRIG_LATCH
	errs	+= query_test(args->fd);				// AI32SSC1M_IOCTL_QUERY
	errs	+= rag_enable_test(args->fd);			// AI32SSC1M_IOCTL_RAG_ENABLE
	errs	+= rag_nrate_test(args->fd);			// AI32SSC1M_IOCTL_RAG_NRATE
	errs	+= rbg_clk_src_test(args->fd);			// AI32SSC1M_IOCTL_RBG_CLK_SRC
	errs	+= rbg_enable_test(args->fd);			// AI32SSC1M_IOCTL_RBG_ENABLE
	errs	+= rbg_nrate_test(args->fd);			// AI32SSC1M_IOCTL_RBG_NRATE
	errs	+= reg_mod_test(args->fd);				// AI32SSC1M_IOCTL_REG_MOD
	errs	+= reg_read_test(args->fd);				// AI32SSC1M_IOCTL_REG_READ
	errs	+= reg_write_test(args->fd);			// AI32SSC1M_IOCTL_REG_WRITE
	errs	+= rx_io_abort_test(args->fd);			// AI32SSC1M_IOCTL_RX_IO_ABORT
	errs	+= rx_io_mode_test(args->fd);			// AI32SSC1M_IOCTL_RX_IO_MODE
	errs	+= rx_io_overflow_test(args->fd);		// AI32SSC1M_IOCTL_RX_IO_OVERFLOW
	errs	+= rx_io_timeout_test(args->fd);		// AI32SSC1M_IOCTL_RX_IO_TIMEOUT
	errs	+= rx_io_underflow_test(args->fd);		// AI32SSC1M_IOCTL_RX_IO_UNDERFLOW
	errs	+= samp_clk_src_test(args->fd);			// AI32SSC1M_IOCTL_SAMP_CLK_SRC
	errs	+= scan_marker_test(args->fd);			// AI32SSC1M_IOCTL_SCAN_MARKER
	errs	+= scan_marker_get_test(args->fd);		// AI32SSC1M_IOCTL_SCAN_MARKER_GET
	errs	+= scan_marker_set_test(args->fd);		// AI32SSC1M_IOCTL_SCAN_MARKER_SET
	errs	+= wait_event_test(args->fd);			// AI32SSC1M_IOCTL_WAIT_EVENT
	errs	+= wait_cancel_test(args->fd);			// AI32SSC1M_IOCTL_WAIT_CANCEL
	errs	+= wait_status_test(args->fd);			// AI32SSC1M_IOCTL_WAIT_STATUS

	return(errs);
}


