// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/samples/sbtest/pretrig_count.c $
// $Rev: 53596 $
// $Date: 2023-08-23 15:57:48 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// There are no static bits to test.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// We're not going to perform a functional test.
	return(0);
}



/******************************************************************************
*
*	Function:	pretrig_count_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AI32SSC1M_IOCTL_PRETRIG_COUNT.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int pretrig_count_test(int fd)
{
	int	errs	= 0;
	s32	pretrig;

	gsc_label("AI32SSC1M_IOCTL_PRETRIG_COUNT");
	errs	+= ai32ssc1m_query(fd, -1, 0, AI32SSC1M_QUERY_PRETRIG, &pretrig);

	if (errs)
	{
		printf("FAIL <---\n");
	}
	else if (pretrig == 0)
	{
		printf("SKIPPED  (Not supported in this firmware.)\n");
	}
	else
	{
		errs	+= _service_test(fd);
		errs	+= _function_test(fd);
		printf("%s\n", errs ? "FAIL <---" : "PASS");
	}

	return(errs);
}


