// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/samples/sbtest/query.c $
// $Rev: 53596 $
// $Date: 2023-08-23 15:57:48 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	s32	data;
	s32	count;
	int	errs;
	int	i;

	errs	= ai32ssc1m_query(fd, -1, 0, AI32SSC1M_QUERY_COUNT, &count);

	if (errs)
	{
		printf(	"FAIL <---  (ai32ssc1m_query() error)\n");
	}
	else if (count != (AI32SSC1M_IOCTL_QUERY_LAST + 1))
	{
		errs	= 1;
		printf(	"FAIL <---  (expected %ld, got %ld, rebuild application)\n",
				(long) AI32SSC1M_IOCTL_QUERY_LAST,
				(long) count);
	}
	else
	{
		for (i = 0; (errs == 0) && (i < AI32SSC1M_IOCTL_QUERY_LAST); i++)
		{
			errs	= ai32ssc1m_query(fd, -1, 0, i, &data);

			if (errs)
			{
				printf(	"FAIL <---  (ai32ssc1m_query(%d) error)\n", i);
				break;
			}
		}
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	return(0);
}



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AI32SSC1M_IOCTL_QUERY.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	int	errs	= 0;

	gsc_label("AI32SSC1M_IOCTL_QUERY");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


