// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/samples/sbtest/rag_nrate.c $
// $Rev: 53596 $
// $Date: 2023-08-23 15:57:48 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const s32	args[]	=
	{
		0x0024,
		0x0040,
		0x0080,
		0x0100,
		0x0200,
		0x0400,
		0x0800,
		0x1000,
		0x2000,
		0x4000,
		0x8000,
		0x0024,

		0xFFFF,
		0xFFFE,
		0xFFFD,
		0xFFFB,
		0xFFF7,
		0xFFEF,
		0xFFDF,
		0xFFBF,
		0xFF7F,
		0xFEFF,
		0xFDFF,
		0xFBFF,
		0xF7FF,
		0xEFFF,
		0xDFFF,
		0xBFFF,
		0x7FFF,
		0xFFFF,

		0x0024,
		-1
	};

	int	errs	= 0;

	errs	+= ai32ssc1m_initialize(fd, -1, 0);
	errs	+= service_test_set_reg_reg_get(
				fd,
				__LINE__,
				AI32SSC1M_IOCTL_RAG_NRATE, args,
				AI32SSC1M_GSC_RAGR, 15, 0);
	errs	+= ai32ssc1m_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This test requires external equipment.
	return(0);
}



/******************************************************************************
*
*	Function:	rag_nrate_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AI32SSC1M_IOCTL_RAG_NRATE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int rag_nrate_test(int fd)
{
	int	errs	= 0;

	gsc_label("AI32SSC1M_IOCTL_RAG_NRATE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


