// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/samples/sbtest/scan_marker_set.c $
// $Rev: 53596 $
// $Date: 2023-08-23 15:57:48 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	int	errs	= 0;
	int	i;
	u32	lw;
	u32	smlwr;
	u32	smuwr;
	u32	uw;
	u32	val;

	for (i = -1; i < 32; i++)
	{
		val		= (i < 0) ? 0 : ((u32) 1 << i);
		lw		= val & 0xFFFF;
		uw		= val >> 16;
		errs	+= ai32ssc1m_scan_marker_set(fd, -1, 0, val);
		errs	+= ai32ssc1m_reg_read(fd, -1, 0, AI32SSC1M_GSC_SMLWR, &smlwr);
		errs	+= ai32ssc1m_reg_read(fd, -1, 0, AI32SSC1M_GSC_SMUWR, &smuwr);

		if ((smlwr != lw) || (smuwr != uw))
			errs++;
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// We're not going to perform a functional test.
	return(0);
}



/******************************************************************************
*
*	Function:	scan_marker_set_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AI32SSC1M_IOCTL_SCAN_MARKER_SET.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int scan_marker_set_test(int fd)
{
	int	errs	= 0;

	gsc_label("AI32SSC1M_IOCTL_SCAN_MARKER_SET");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}


