// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/samples/signals/perform.c $
// $Rev: 53594 $
// $Date: 2023-08-23 15:54:59 -0500 (Wed, 23 Aug 2023) $

// 18AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	char	buf[64];
	int		errs	= 0;

	errs	+= ai32ssc1m_initialize		(args->fd, -1, 1);
	errs	+= ai32ssc1m_chan_active	(args->fd, -1, 1, AI32SSC1M_CHAN_ACTIVE_SINGLE,	NULL);
	errs	+= ai32ssc1m_chan_single	(args->fd, -1, 1, 0,								NULL);
	errs	+= ai32ssc1m_clock_enable	(args->fd, -1, 1, AI32SSC1M_CLOCK_ENABLE_YES,	NULL);

	//===============================================================
	gsc_label("Input Clock");
	printf("\n");
	gsc_label_level_inc();
	errs	+= ai32ssc1m_samp_clk_src	(args->fd, -1, 1, AI32SSC1M_SAMP_CLK_SRC_RAG,		NULL);
	errs	+= ai32ssc1m_rag_nrate		(args->fd, -1, 1, 90,								NULL);
	errs	+= ai32ssc1m_rag_enable		(args->fd, -1, 1, AI32SSC1M_GEN_ENABLE_YES,		NULL);
	gsc_label_level_dec();

	//===============================================================
	gsc_label("Output Clock");
	printf("\n");
	gsc_label_level_inc();
	errs	+= ai32ssc1m_rbg_clk_src	(args->fd, -1, 1, AI32SSC1M_RBG_CLK_SRC_RAG,		NULL);
	errs	+= ai32ssc1m_reg_mod		(args->fd, -1, 0, AI32SSC1M_GSC_RBGR, 3, 0xFFFF);
	errs	+= ai32ssc1m_rbg_nrate		(args->fd, -1, 1, -1,								NULL);
	errs	+= ai32ssc1m_rbg_enable		(args->fd, -1, 1, AI32SSC1M_GEN_ENABLE_YES,		NULL);
	errs	+= ai32ssc1m_burst_size		(args->fd, -1, 1, 3,								NULL);
	errs	+= ai32ssc1m_burst_sync		(args->fd, -1, 1, AI32SSC1M_BURST_SYNC_RBG,		NULL);


	errs	+= ai32ssc1m_rbg_clk_src	(args->fd, -1, 1, AI32SSC1M_RBG_CLK_SRC_MASTER,	NULL);
	errs	+= ai32ssc1m_rbg_nrate		(args->fd, -1, 1, 270,							NULL);
	errs	+= ai32ssc1m_rbg_enable		(args->fd, -1, 1, AI32SSC1M_GEN_ENABLE_YES,		NULL);
	errs	+= ai32ssc1m_burst_size		(args->fd, -1, 1, 3,								NULL);
	errs	+= ai32ssc1m_burst_sync		(args->fd, -1, 1, AI32SSC1M_BURST_SYNC_RBG,		NULL);

	gsc_label_level_dec();

	//===============================================================
	sprintf(buf, "Waiting (%ld sec%s)", (long) args->seconds, (args->seconds == 1) ? "" : "s");
	gsc_label(buf);
	fflush(stdout);
	os_sleep_ms(args->seconds * 1000);
	printf("Done\n");

	errs	+= ai32ssc1m_initialize		(args->fd, -1, 1);

	return(errs);
}



