// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/utils/util_ext_clk_div_ena.c $
// $Rev: 44165 $
// $Date: 2018-11-20 14:44:06 -0600 (Tue, 20 Nov 2018) $

// 18AI32SSC1M: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssc1m_aux_out_pol
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSC1M_IOCTL_EXT_CLK_DIV_ENA service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai32ssc1m_ext_clk_div_ena(int fd, int index, int verbose, s32 set, s32* get)
{
	char		buf[128];
	int			errs;
	const char*	ptr;
	int			ret;

	if (verbose)
		gsc_label_index("Ext Clock Division", index);

	ret		= ai32ssc1m_ioctl(fd, AI32SSC1M_IOCTL_EXT_CLK_DIV_ENA, &set);
	errs	= ret ? 1 : 0;

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case AI32SSC1M_EXT_CLK_DIV_ENA_NO:

			ptr	= "Disable";
			break;

		case AI32SSC1M_EXT_CLK_DIV_ENA_YES:

			ptr	= "Enable";
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);

	if (get)
		get[0]	= set;

	return(errs);
}


