// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/utils/util_rbg_nrate.c $
// $Rev: 44165 $
// $Date: 2018-11-20 14:44:06 -0600 (Tue, 20 Nov 2018) $

// 18AI32SSC1M: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssc1m_rbg_nrate
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSC1M_IOCTL_RBG_NRATE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai32ssc1m_rbg_nrate(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Rate-B Generator Nrate", index);

	ret		= ai32ssc1m_ioctl(fd, AI32SSC1M_IOCTL_RBG_NRATE, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf("%s  (", errs ? "FAIL <---" : "PASS");
		gsc_label_long_comma(set);
		printf(")\n");
	}

	if (get)
		get[0]	= set;

	return(errs);
}


