// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI32SSC1M/utils/util_scan_marker_get.c $
// $Rev: 44165 $
// $Date: 2018-11-20 14:44:06 -0600 (Tue, 20 Nov 2018) $

// 18AI32SSC1M: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssc1m_scan_marker_get
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSC1M_IOCTL_SCAN_MARKER_GET service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	ai32ssc1m_scan_marker_get(int fd, int index, int verbose, u32* get)
{
	int	errs;
	int	ret;
	u32	set;

	if (verbose)
		gsc_label_index("Scan Marker Get", index);

	ret		= ai32ssc1m_ioctl(fd, AI32SSC1M_IOCTL_SCAN_MARKER_GET, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (0x%08lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


